;hide.asm

OLDDIRLEN	EQU	80
SECTSIZE	EQU	512

CSEG    SEGMENT PARA PUBLIC 'CODE'
        ORG     100h
        ASSUME CS:CSEG ,DS:CSEG
start:
	call	copyright	;display copyright
	call	getver		;get dos version
;*************************************************
;*      HH                    *
;*************************************************
	mov	di,81h
	mov	al,20h
	mov	cx,0ffh
	rep	scasb		;find 1st non-space symbol
	dec	di
	push	di		;ptr to mypath
l1:	inc	di
	cmp	byte ptr [di],' '
	ja	l1		;search any end of line
	mov	byte ptr [di],0
	pop	dx		;ptr to mypath

;**************************************************
;*          GET   MYDISK		          *
;**************************************************
;dx - mydir name
	mov	si,dx
	cmp	byte ptr [si+1],':'	;another disk ?
	jne	current_disk
	mov	al,[si]		;drive letter
;	add	si,3		;skip drive letter
	cmp	al,'Z'		;caps ?
	jbe	caps
	sub	al,'a'
	jmp	disk_ok
caps:	sub	al,'A'
	jmp	disk_ok
current_disk:
;**************************************************
;*        GET CURRENT DISK 			  *
;**************************************************
	mov	ah,19h
	int	21h
disk_ok:
	mov	mydisk,al	;keep disk of path
	mov	mydir_ptr,si	;keep ptr to path
;************************************************
;*	GET PTR TO DEFAULT DIR FOR MYDISK	*
;************************************************
	mov	ah,52h
	int	21h		;get list of lists
        les     bx,es:[bx+16h]  ;list default dir
	mov	al,mydisk
	mov	cl,58h
	cmp	drdos,1
	jne	gpd1
	mov	cl,51h
gpd1:	mul	cl
	add	bx,ax			;es:bx = offset to def dir for mydisk
	mov	mydisk_ptr,bx
	mov	mydisk_ptr+2,es
;************************************************
;*	KEEP OLD DIR 				*
;************************************************
	push	ds
	push	ds
	pop	es
	lds	si,dword ptr mydisk_ptr
	lea	di,olddir
	mov	cx,3		;"d:\"
	rep	movsb
	pop	ds

	mov	si,di
	mov	dl,mydisk
	inc	dl
	mov	ah,47h
	int	21h			;get current dir for mydisk->ds:si
;****************************************
;*	GET MYDIR\.. NAME		*
;****************************************
	push	ds
	pop	es
	mov	di,mydir_ptr		;ptr to my path name
	xor	al,al
	mov	cx,0ffh
	cld
	repne	scasb			;find 0 (end of string)
gmnloop1:
	dec	di
	mov	al,byte ptr [di]

	cmp	al,'\'
	je	gmn_ok
	cmp	di,mydir_ptr
	jb	gmn_ok
	jmp	gmnloop1
gmn_ok:
	push	di
	inc	di
	mov	si,di
	push	ds
	pop	es
	lea	di,fcb_name
	mov	ax,2902h
	int	21h		;parse filename (my dir name)
	pop	di
	cmp	byte ptr [di-1],':'	;root dir ?
	jne	noroot
	inc	di
noroot:	mov	byte ptr [di],0	;asciiz path = mypath\.. or d:\
	cmp	di,mydir_ptr	;if no path specified
	jb	cmd_ok		;no change dir
;************************************************
;*	CHANGE DEFAULT DIR TO MYDIR\..		*
;************************************************
	mov	dx,mydir_ptr
	mov	ah,3bh
	int	21h
	jnc	cmd_ok
	jmp	cmd_error
cmd_ok:
	mov	sp_seg,ds
	mov	sp_off,offset sector
	call	get_boot_parms	;get parameters from boot sector

;****************************************
;*	GET START CLUSTER		*
;****************************************
	push	es
	les	di,dword ptr mydisk_ptr
	mov	ax,es:[di+49h]		;start cluster
	cmp	drdos,1
	jnz	gsc1
	mov	ax,es:[di+4bh]		;for DR DOS
gsc1:	pop	es
	call	conv_to_sector
		
;****************************************
;*      UPDATING DIR INFO		*
;****************************************
;⠥ ᥪp ⠫
s_read:
        push    ax                      ; p ᥪp
	push	dx
	call	read_sector		;read 1 sector from mydisk at AX
	pop	dx
	pop	ax		;sect_no

	cld
	lea	di,sector	
compare:
	lea	si,fcb_name+1	;parsed file(dir)name
	push	di
	mov	cx,0bh
	repe	cmpsb		
	pop	di
	jcxz	found_ok
	add	di,20h		;switch to next entry
	cmp	di,offset sector+SECTSIZE
	jb	compare
	add	ax,1		;inc sector_no
	adc	dx,0
	sub	read_count,1
	jnz	s_read		;read next sector
	jmp	dir_not_found


found_ok:
;******************************************************************************
	mov	cl,8h
	xor	[di+0bh],cl	;set volume label bit
	test	[di+0bh],cl
	jnz	h_complete
	mov	msg_ptr,offset unh_compl
	jmp	h_ok
h_complete:
	mov	msg_ptr,offset h_compl
h_ok:
;******************************************************************************
;restore old current dir
	push	ax
	push	dx
	lea	dx,olddir
	mov	ah,3bh
	int	21h
	pop	dx
	pop	ax
; 
	call	write_sector
	mov	dx,msg_ptr
	jmp	de

cmd_error:
	lea	dx,chd_error
	jmp	de
read_error:
	lea	dx,sr_error
	jmp	de
write_error:
	lea	dx,sw_error
	jmp	de
prevdir_error:
	lea	dx,prev_error
	jmp	de
dir_not_found:
	lea	dx,notfound
	
de:	mov	ah,9
	int	21h
	mov	ax,4c00h
	int	21h

;************************************************
;*	CONVERT CLUSTER_NO TO SECTOR_NO		*
;************************************************
conv_to_sector	PROC	NEAR
;		USES	CX
;************** AX = CLUSTER_NO *********************
	push	cx
;pp㥬  p ᥪp
        or      ax,ax                   ;0-᫨ p ⠫
        jnz     ekc1
        mov     ax,first_data_sector    ;砫 p ⠫
	cwd
        jmp     ekc2
ekc1:   sub     ax,2                    ;2= p p
        mov     cl,sect_per_cluster
	xor	ch,ch
        mul     cx
        add     ax,first_data_sector    ; + 砫 p ⠫
	adc	dx,0
        add     ax,sect_per_root        ; + ᥪp  p ⠫
	adc	dx,0
ekc2:   
	pop	cx
	ret
;************* DX,AX = SECTOR_NO *********************
conv_to_sector ENDP

;**************************************************
;*         BOOT-                      *
;**************************************************
get_boot_parms	PROC	NEAR

	push	ax
	push	bx
	push	cx
	push	dx
	xor	ax,ax
	xor	dx,dx
	call	read_sector
;*************************************************
;*       H HH  H       *
;*       H   H        *
;*************************************************
        mov     ax,word ptr sector[11h] ;᫮ -⮢ p ⠫
        mov     cx,32
        mul     cx              
        mov     cx,word ptr sector[0bh] ;bytes per sector
        div     cx            		;ax= ᥪp p ⠫
        mov     sect_per_root,ax
        mov     ax,word ptr sector[16h] ;sectors per FAT
        mov     cl,sector[10h]     	;᫮ FAT
        mul     cl              	;ax= ᥪp FAT
        add     ax,word ptr sector[0eh] ;+- ᥪp p FAT
        mov     first_data_sector,ax    ;p ᥪp 
        mov     al,sector[0dh]     	;sectors per cluster
        mov     sect_per_cluster,al    
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
get_boot_parms	ENDP

;****************************************
;*	READ SECTOR DX,AX		*
;****************************************
read_sector	PROC	NEAR
	mov	word ptr sect_parms,ax
	mov	word ptr sect_parms+2,dx
	cmp	bigdos,1
	je	big_read

	mov	dx,ax		;sector no
	mov	al,mydisk
	mov	cx,1		;1 sector
	lea	bx,sector
	int	25h
	pop	bx
	jnc	read_ok
big_read:
	mov	cx,-1
	lea	bx,sect_parms
	mov	al,mydisk
	int	25h
	pop	bx
	jnc	big_read_ok
	jmp	read_error
big_read_ok:
	mov	bigdos,1
read_ok:
	ret
read_sector	ENDP

;****************************************
;*	WRITE SECTOR DX,AX 		*
;****************************************
write_sector	PROC	NEAR
	mov	word ptr sect_parms,ax
	mov	word ptr sect_parms+2,dx
	cmp	bigdos,1
	je	big_write

	mov	dx,ax		;sector no
	mov	al,mydisk
	mov	cx,1		;1 sector
	lea	bx,sector
	int	26h
	pop	bx
	jnc	read_ok
big_write:
	mov	cx,-1
	lea	bx,sect_parms
	mov	al,mydisk
	int	26h
	pop	bx
	jnc	big_write_ok
	jmp	write_error
big_write_ok:
write_ok:
	ret
write_sector	ENDP

copyright	PROC	NEAR
	lea	dx,mycpr
	mov	ah,9
	int	21h
	ret
copyright	ENDP

usage		PROC	NEAR
	lea	dx,usg
	mov	ah,9
	int	21h
	ret
usage		ENDP

getver		PROC	NEAR
	mov	ax,3000h
	int	21h
	cmp	ax,1f03h
	jne	ms
	lea	dx,dr_msg
	mov	ah,9
	int	21h
	mov	drdos,1
ms:
	ret
getver		ENDP

;DSEG	SEGMENT PARA PUBLIC 'DATA'
first_data_sector	dw	?
sect_per_root		dw	?
sect_per_cluster	db	?

msg_ptr		dw	?
mydir_ptr	dw	?
mydisk_ptr	dw	2 dup (?)
mydisk		db	?
bigdos		db	0	;flag extended dos partition
prevdir		db	'..',0
olddir		db	OLDDIRLEN dup (?)
read_count	db	5
drdos		db	0

mycpr		db	'Subdirectory hide (C)SAE 1993 v1.01',0dh,0ah,'$'
		db	'*Sgibnev Alexandr E. 694117(h)*'
usg		db	'Usage: hide <[d:\]path>',0dh,0ah,'$'
chd_error	db	'Path not found',0dh,0ah,'$'
sr_error	db	'Sector read error',0dh,0ah,'$'
sw_error	db	'Sector write error',0dh,0ah,'$'
prev_error	db	'Cannot hide root catalog',0dh,0ah,'$' 
notfound	db	'Directory not found',0dh,0ah,'$'
unh_compl	db	'UNHIDE COMPLETE !',0dh,0ah,'$'
h_compl		db	'HIDE COMPLETE !',0dh,0ah
		db	'(for unhide run me again)',0dh,0ah,'$'
dr_msg		db	'Running under DR-DOS ...',0ah,0dh,'$'

sect_parms	dd	?	;sector
		dw	1	;sector count
sp_off		dw	?	;buf offset
sp_seg		dw	?	;buf segment
fcb_name	db	?
		db	11 dup (?)
sector		db	SECTSIZE dup (?)

;DSEG	ENDS

	end	start
CSEG	ENDS
	END
